%define	with_python_subpackage	1%{nil}
%define	with_python_version	2.2%{nil}
%define	with_bzip2		1%{nil}
%define with_internal_db	1%{nil}
%define strip_binaries		1
%define with_apidocs		0

# XXX enable at your own risk, CDB access to rpmdb isn't cooked yet.
%define	enable_cdb		create cdb

# XXX legacy requires './' payload prefix to be omitted from rpm packages.
%define	_noPayloadPrefix	1

%define	__prefix	/usr
%{expand: %%define __share %(if [ -d %{__prefix}/share/man ]; then echo /share ; else echo %%{nil} ; fi)}

Summary: The RPM package management system.
Name: librpm404
%define version 4.0.4
Version: %{version}
%{expand: %%define rpm_version %{version}}
Release: 8x.27
Group: System Environment/Base
Source: ftp://ftp.rpm.org/pub/rpm/dist/rpm-4.0.x/rpm-%{rpm_version}.tar.gz
PAtch0: librpm404-versionpythonmodule.diff
Patch1: rpm404-athloncpuid.patch
Patch2: rpm404-athloncpuid-2.patch
Copyright: GPL
Conflicts: patch < 2.5
%ifos linux
Prereq: gawk fileutils textutils mktemp shadow-utils
%endif

%if !%{with_internal_db}
BuildRequires: db3-devel

# XXX glibc-2.1.92 has incompatible locale changes that affect statically
# XXX linked binaries like /bin/rpm.
%ifnarch ia64
Requires: glibc >= 2.1.92
%endif
%endif

BuildRequires: zlib-devel
# XXX Red Hat 5.2 has not bzip2 or python
%if %{with_bzip2}
BuildRequires: bzip2 >= 0.9.0c-2
%endif
%if %{with_python_subpackage}
BuildRequires: python-devel >= %{with_python_version}
%endif

BuildRoot: %{_tmppath}/%{name}-root

%description
The RPM Package Manager (RPM) is a powerful command line driven
package management system capable of installing, uninstalling,
verifying, querying, and updating software packages. Each software
package consists of an archive of files along with information about
the package like its version, a description, etc.

%if %{with_python_subpackage}
%package -n rpm404-python
Summary: Python bindings for apps which will manipulate RPM packages.
Group: Development/Libraries
Requires: librpm404 = %{rpm_version}
Requires: python >= %{with_python_version}

%description -n rpm404-python
The rpm-python package contains a module that permits applications
written in the Python programming language to use the interface
supplied by the RPM Package Manager libraries.

This package should be installed if you want to develop Python
programs that will manipulate RPM packages and databases.

%package devel
Summary: Development files for manipulating RPM packages.
Group: Development/Libraries
Requires: librpm404 = %{rpm_version}, popt

%description devel
This package contains the RPM C library and header files for librpm 4.0.4. 
These development files will simplify the process of writing programs that
manipulate RPM packages and databases. These files are intended to
simplify the process of creating graphical package managers or any
other tools that need an intimate knowledge of RPM packages in order
to function.

This package should be installed if you want to develop programs that
will manipulate RPM packages and databases using the old API.

%endif

%prep
%setup -q -n rpm-4.0.4
%patch0 -p1 
%patch1 -p1
%patch2 -p0

%build

%ifarch alpha
CFLAGS="$RPM_OPT_FLAGS -fPIC"; export CFLAGS
%endif
%ifos linux
CFLAGS="$RPM_OPT_FLAGS $CFLAGS" ./configure --prefix=%{__prefix} --sysconfdir=/etc --localstatedir=/var --infodir='${prefix}%{__share}/info' --mandir='${prefix}%{__share}/man' --with-python=%{with_python_version} --without-javaglue
%else
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{__prefix}
%endif

# XXX workaround ia64 gcc-3.1-0.18 miscompilation
%ifarch ia64
make CFLAGS="-g -O0 -DIA64_SUCKS_ROCKS" files.o files.lo -C build
%endif

make

%install
rm -rf $RPM_BUILD_ROOT

make DESTDIR="$RPM_BUILD_ROOT" install

%if %{strip_binaries}
{ cd $RPM_BUILD_ROOT
  %{__strip} ./bin/rpm
  %{__strip} .%{__prefix}/bin/rpm2cpio
}
%endif

# crude hack
mv $RPM_BUILD_ROOT/%{__prefix}/include/rpm $RPM_BUILD_ROOT/%{__prefix}/include/rpm-4.0.4
mv $RPM_BUILD_ROOT/%{__prefix}/lib/librpm.a $RPM_BUILD_ROOT/%{__prefix}/lib/librpm-4.0.4.a
mv $RPM_BUILD_ROOT/%{__prefix}/lib/librpmdb.a $RPM_BUILD_ROOT/%{__prefix}/lib/librpmdb-4.0.4.a
mv $RPM_BUILD_ROOT/%{__prefix}/lib/librpmio.a $RPM_BUILD_ROOT/%{__prefix}/lib/librpmio-4.0.4.a
mv $RPM_BUILD_ROOT/%{__prefix}/lib/librpmbuild.a $RPM_BUILD_ROOT/%{__prefix}/lib/librpmbuild-4.0.4.a

%if %{with_python_subpackage}
mv $RPM_BUILD_ROOT/%{__prefix}/lib/python%{with_python_version}/site-packages/rpmmodule.so $RPM_BUILD_ROOT/%{__prefix}/lib/python%{with_python_version}/site-packages/rpm404module.so
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%ifos linux
/sbin/ldconfig
%endif
exit 0

%ifos linux
%postun
/sbin/ldconfig
%endif

%define	rpmattr		%attr(0755, rpm, rpm)

%files
%defattr(-,root,root)
%doc RPM-PGP-KEY RPM-GPG-KEY CHANGES GROUPS doc/manual/[a-z]*
%{__prefix}/lib/librpm-4.0.4.so
%{__prefix}/lib/librpmdb-4.0.4.so
%{__prefix}/lib/librpmio-4.0.4.so
%{__prefix}/lib/librpmbuild-4.0.4.so

%files devel
%defattr(-,root,root)
%if %{with_apidocs}
%doc apidocs
%endif
%{__prefix}/include/rpm-4.0.4
%{__prefix}/lib/librpm-4.0.4.a
%{__prefix}/lib/librpmdb-4.0.4.a
%{__prefix}/lib/librpmio-4.0.4.a
%{__prefix}/lib/librpmbuild-4.0.4.a

%if %{with_python_subpackage}
%files -n rpm404-python
%defattr(-,root,root)
%{__prefix}/lib/python%{with_python_version}/site-packages/rpm404module.so
#%{__prefix}/lib/python%{with_python_version}/site-packages/poptmodule.so
%endif

%changelog
* Tue Aug 27 2002 Jeremy Katz <katzj@redhat.com>
- more crude hackery

* Thu Jul 25 2002 Jeremy Katz <katzj@redhat.com>
- workaround athlon detection miscompile

* Wed Jul 24 2002 Jeremy Katz <katzj@redhat.com>
- rebuild

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Jun 10 2002 Jeremy Katz <katzj@redhat.com>
- namespace rpmmodule to be rpm404module
- add devel package with all versioned libs and includes

* Thu May 30 2002 Jeremy Katz <katzj@redhat.com>
- fix deps

* Tue May 28 2002 Jeremy Katz <katzj@redhat.com>
- rpm-python -> rpm404-python

* Fri May 17 2002 Jeremy Katz <katzj@redhat.com>
- turn into librpm404 compat package.  still build the python bindings 
  here as rpm-python

* Fri Apr 26 2002 Jeff Johnson <jbj@redhat.com>
- fix: rpmdb iterator memory leak in python bindings.

* Fri Apr 19 2002 Jeff Johnson <jbj@redhat.com>
- fix: packages produced by rpm-4.0 dinna merge signature tags.

* Thu Apr 18 2002 Jeff Johnson <jbj@redhat.com>
- fix: queries that evaluated to "" incorrectly returned NULL.

* Thu Apr 11 2002 Jeff Johnson <jbj@redhat.com>
- fix: generate config file md5 as ascii, not binary (#62542).

* Fri Apr  5 2002 Jeff Johnson <jbj@redhat.com>
- non-glibc: on upgrade, mergesort is much faster than quicksort.

* Thu Apr  4 2002 Jeff Johnson <jbj@redhat.com>
- speedup large queries by ~50%.
- revert to presentation ordering Yet Again (#62158).

* Wed Mar 27 2002 Jeff Johnson <jbj@redhat.com>
- fix: look for "/path" in Providename as well as Basenames (#59665).
- fix: avoid /dev/log installation more carefully (#62012).
- fix: don't compile beecrypt java bindings (#61992).
- solaris: save main() envp in global environ for use with gpg.
- don't add empty md5 strings to Filemd5's index.
- create Filemd5 index with binary, not ascii, keys.

* Fri Mar 22 2002 Jeff Johnson <jbj@redhat.com>
- fix: make sure that .rpmsave files are created (#57078).

* Mon Mar 18 2002 Jeff Johnson <jbj@redhat.com>
- fix: one-step-too-far when searching added package provides (#61388).
- fix: avoid libio misconfiguration with bleeding edge glibc.
- fix: add quotes around [:blank:] in linux find-provides.
- make --addsign and --resign behave exactly the same.
- *really* dump signature header immutable region.
- fix: don't overflow result buffer if gpg/pgp gives copious output.

* Fri Mar 15 2002 Jeff Johnson <jbj@redhat.com>
- re-enable FD_CLOEXEC, the problem is in zlib through mmap.
- add toy python callbacks for payload unpacking failure(s).

* Wed Feb 13 2002 Jeff Johnson <jbj@redhat.com>
- don't do close-on-exec, 2 powertools packages cannot be read when doing.
- reapply Berkeley DB patch #4491.

* Thu Feb  7 2002 Jeff Johnson <jbj@redhat.com>
- rpm-4.0.4 release candidate.
- add cpanflute2, another perl.req fiddle.
- another cpanflute2 patch.

* Mon Feb  4 2002 Jeff Johnson <jbj@redhat.com>
- generate index for pkgid (aka Sigmd5) tag, query/verify by pkgid.
- generate index for hdrid (aka Sha1header) tag, query/verify by hdrid.
- generate index for fileid (aka Filemd5s) tag, query/verify by fileid.
- query/verify by install transaction id.

* Sun Feb  3 2002 Jeff Johnson <jbj@redhat.com>
- transaction rollbacks are functional.

* Sat Feb  2 2002 Jeff Johnson <jbj@redhat.com>
- fix: drop header region when writing repackaged legacy header.
- bail on %files macro.

* Fri Feb  1 2002 Jeff Johnson <jbj@redhat.com>
- macro for %%files, always include %%defattr(), redhat config only.

* Thu Jan 31 2002 Jeff Johnson <jbj@redhat.com>
- permit args to be hidden within %%__find_{requires,provides}.
- a couple more perl.{prov,req} fiddles.

* Wed Jan 30 2002 Jeff Johnson <jbj@redhat.com>
- legacy: configurable whiteout for known Red Hat dependency loops.
- perl.req: don't mis-generate dependencies like perl(::path/to/foo.pl).
- use chainsaw algorithm for dependency tree decimation when ordering.

* Tue Jan 29 2002 Jeff Johnson <jbj@redhat.com>
- transaction rollback code in rpmRollback().
- Red Hat 6.2 portability cruft.

* Sun Jan 27 2002 Jeff Johnson <jbj@redhat.com>
- fix: fancy hash fiddles if not a tty.
- fix: handle /.../ correctly in rpmCleanPath().

* Sat Jan 26 2002 Jeff Johnson <jbj@redhat.com>
- fix: %exclude functional (again).
- trap SIGILL for ppc64 inline asm voodoo fix from cross-dressed ppc32.
- rpm-perl: force numeric comparison on rpm version (#58882).

* Tue Jan 22 2002 Jeff Johnson <jbj@redhat.com>
- fix: query format qualifiers needed header.c merge.
- ppc64 arch added (#58634,#58636).
- turn on auto-generated perl requirements (#58519, #58536, #58537).
- add internal (customized) version of zlib.

* Mon Jan 21 2002 Jeff Johnson <jbj@redhat.com>
- sync rpmdb and build with rpm-4.1, lots of splint annotations.
- add :armor and :base64 query format qualifiers for binary signatures.

* Sat Jan 19 2002 Jeff Johnson <jbj@redhat.com>
- use beecrypt routines to calculate digests in rpm.
- dump legacy support for broken md5 signatures.
- sync popt and rpmio with rpm-4.1, rpmio has OpenPGP API.

* Thu Jan 17 2002 Jeff Johnson <jbj@redhat.com>
- missing key(s) on keyring when verifying a signature is now an error.
- remove dependency whiteout.
- calculate rpm-4.1 ordering/orientation metrics in rpmdepOrder().

* Fri Jan 11 2002 Jeff Johnson <jbj@redhat.com>
- permit subset installs for %lang colored hardlink file sets.

* Thu Jan 10 2002 Jeff Johnson <jbj@redhat.com>
- fix: signing multiple times dinna work, discard immutable region.
- remove poptmodule.so for separate packaging.

* Wed Jan  9 2002 Jeff Johnson <jbj@redhat.com>
- permit gpg/pgp/pgp5 execs to be reconfigured.

* Tue Jan  8 2002 Jeff Johnson <jbj@redhat.com>
- use db-4.0.14 final internally.
- make rpm-perl package self-hosting (#57748).

* Mon Jan  7 2002 Jeff Johnson <jbj@redhat.com>
- Depends should use CDB if configured.
- autodetect python 1.5/2.2.

* Sun Jan  6 2002 Jeff Johnson <jbj@redhat.com>
- handle lazy db open's in chroot with absolute path, not prefix strip.

* Sat Jan  5 2002 Jeff Johnson <jbj@redhat.com>
- sparc: make dbenv per-rpmdb, not per-dbi.

* Thu Dec 20 2001 Jeff Johnson <jbj@redhat.com>
- tru64 compiler message cleanup.
- add buildarch lines for hppa (#57728).

* Wed Dec 19 2001 Jeff Johnson <jbj@redhat.com>
- look for PY_VERSION 2.2c1.
- fix: typo in find-requires.

* Sun Dec  9 2001 Jeff Johnson <jbj@redhat.com>
- solaris: translate i86pc to i386 (#57182).
- fix: %%GNUconfigure breaks with single quotes (#57264).

* Mon Dec  3 2001 Jeff Johnson <jbj@redhat.com>
- rpm-4.0.4 started.
- turn off rpm-perl until it's self-hosting.
- jigger up rpm-python with python-2.2b2 for now.
- remove libtoolize from %%configure for now (#57039).
- teach find-requires to autogenerate GCC_3.0 dependencies.
